<template>
  <AppAbstractPage :breadcrumbs="breadcrumbs">
    <div
      slot="heading"
      class="pageHeading">
      <div class="pageHeading-basic">
        <h1 class="heading _h1">
          {{ title }}
        </h1>
      </div>
    </div>

    <div
      slot="content"
      class="contractParts">

      <div class="contractParts-filters">
        <div
          class="boxFilters"
          :class="{ '-open-in-mobile': display === $options.displayStates.FILTERS }">
          <ContractFilters
            class="__box-gray"
            v-model="filtersModel"
            :scrollable="filtersMobileScrollable"
            :values="filtersValues"
            @hide="changeDisplay($options.displayStates.LIST)"
            @reset="resetFilters"/>
        </div>
      </div>
      <AppWarning
        v-if="emptyResult.city || emptyResult.filters">
        <template slot="warning">
          <div class="ppn-contract-no-enitites">
            <div
              v-if="emptyResult.city"
              class="paragraph">
              В вашем городе нет объявлений.
            </div>
            <div
              v-if="emptyResult.filters"
              class="paragraph">
              По вашему запросу нет объявлений.
            </div>
            <div class="row">
              <ul class="list">
                <li>
                  <span class="dot circle-separator"/>
                  Найти в
                  <button
                    @click="showLocationModal"
                    class="link">другом городе
                  </button>
                </li>
                <li>
                  <span class="dot circle-separator"/>
                  Найти в
                  <flink
                    href="/poisk-po-nomeru"
                    domain="main"
                    class="link">новых запчастях
                  </flink>
                </li>
                <li>
                  <span class="dot circle-separator"/>
                  Отправить
                  <flink
                    href="/request-to-spare"
                    domain="main"
                    class="link">запрос на запчасть
                  </flink>
                </li>
              </ul>
            </div>
          </div>
        </template>
      </AppWarning>

      <!-- <div class="contractParts-popular">
        <div class="boxPopular">
          <div class="boxPopular-title">Все категории</div>
          <ul class="boxPopular-list">
            <li
              v-for="(item, index) in 28"
              :key="`list-${index}`"
              class="boxPopular-item">
              <span class="link">Lorem ipsum {{ item }}</span>
            </li>
          </ul>
          <div class="boxPopular-button">
            <button class="link linkDark _add-arrow">Показать еще</button>
          </div>
        </div>
      </div> -->

      <div class="contractParts-warning">
        <div class="row __space-between">
          <div class="heading _h2">
            Найдено {{ (emptyResult.filters || emptyResult.city ? '0' : grid.count) | spacifyNumber }}
            {{ (emptyResult.filters || emptyResult.city ? '0' : grid.count)
              | spacifyNumber
              | transChoose(['объявление', 'объявления', 'объявлений'])
            }}
          </div>
          <ButtonsCallHelper v-if="emptyResult.filters || emptyResult.city"/>
        </div>
      </div>

      <div class="contractParts-table">
        <GridHeader :title="grid.name">
          <AppButton
            slot="btn-filter"
            @click.native="changeDisplay($options.displayStates.FILTERS)"
            :classes="['buttonFilters', '_blue']">
            <span
              slot="button-item"
              class="button-item">
              <img
                svg-inline
                src="~/assets/svg/redesign/filter-funnel.svg">
              Фильтры
            </span>
          </AppButton>
          <SelectSorting
            :options="sorting"
            slot="btn-sorting"
            :value="selectedSorting"
            @order-change="onOrderChange"/>
        </GridHeader>

        <AppTable
          class="tableContracts"
          :table-headings="$options.headingsСontract"
          :grid="grid"
          :has-lazy-load="lazyLoadEnabled"
          @load-data="showMore(); $ym('show_more_announcements');"
          @order-change="onOrderChange">
          <template #free-box>
            <button class="buttonPopular">
              Популярное
              <img
                svg-inline
                src="~/assets/svg/redesign/button-arrow-right.svg">
            </button>
          </template>

          <!-- Ячейки с данными для таблицы -->

          <!--картинка - слайдер-->
          <template
            :slot="`unit-${$options.headingsСontract[0].name}`"
            slot-scope="{ part }">
            <div
              v-if="part.seller.__typename === $options.SellerType.USER"
              class="sellerPrivate">Частное объявление</div>
            <flink
              :href="`/do/part/${part.id}`"
              @click.native="$ym('click_ads_block')"
              target="_blank">
              <div class="picture">
                <img
                  v-if="part.images.length && part.images[0].big"
                  :src="`${$config.imagesBaseUrl}${part.images[0].big.url}`"
                  :alt="part.title">
                <img
                  v-else
                  svg-inline
                  src="~/assets/svg/redesign/navigation-parts.svg">
              </div>
            </flink>
          </template>

          <!--название запчасти / тип объявления-->
          <template
            :slot="`unit-${$options.headingsСontract[1].name}`"
            slot-scope="{ part }">
            <div
              v-if="part.seller.__typename === $options.SellerType.USER"
              class="sellerPrivate">Частное объявление</div>
            <flink
              :href="`/do/part/${part.id}`"
              @click.native="$ym('click_ads_block')"
              target="_blank"
              class="buttonIsMobile"/>
            <flink
              :href="`/do/part/${part.id}`"
              @click.native="$ym('click_ads_block')"
              target="_blank"
              class="link">
              {{ part.name | sellerPartName }}
            </flink>
            <ul class="characteristics-list">
              <li
                v-for="charc in getCharacteristics(part).slice(0, 3)"
                :key="charc.name"
                class="characteristics-list-item __hide-shadow">
                <span class="__medium">{{ `${charc.name}: ` }}</span>
                <span>{{ charc.value }}</span>
              </li>
              <li
                class="characteristics-list-item additional-link"
                v-if="getCharacteristics(part).length > 3">
                <flink
                  :href="`/do/part/${part.id}`"
                  @click.native="$ym('click_ads_block')"
                  target="_blank"
                  class="link">
                  Показать всё
                </flink>
              </li>
            </ul>
          </template>

          <!--состояние запчасти-->
          <template
            :slot="`unit-${$options.headingsСontract[2].name}`"
            slot-scope="{ part }">
            <span class="valueIsMobile __medium">Состояние: </span>
            <span class="value __bold">{{ getCondition(part) }}</span>
          </template>

          <!--дата добавления объявления-->
          <div
            :slot="`unit-${$options.headingsСontract[3].name}`"
            slot-scope="{ part }">
            <div class="__gray">{{ part.actualAt | dateFormat({ time: true, nouns: true }) | capitalize }}</div>
          </div>

          <!-- срок доставки, наличие или под заказ -->
          <template
            :slot="`unit-${$options.headingsСontract[4].name}`"
            slot-scope="{ part }">
            <span class="valueIsMobile __medium">Срок доставки: </span>
            <div class="values">
              <div
                class="value"
                :class="part.inStock ? 'in-stock-badge' : '__black __medium'">
                {{ part.inStock ? 'В наличии' : 'Под заказ' }}
              </div>
              <div
                class="value"
                v-if="part.quantity"
                :class="{'quantity': !part.inStock }">
                {{ `${part.quantity} шт.` }}
              </div>
            </div>
          </template>

          <!--инфа о продавце-->
          <!-- TODO: wrapper для запчасти -->
          <template
            :slot="`unit-${$options.headingsСontract[5].name}`"
            slot-scope="{ part }">
            <div class="sellerInfoTable">
              <flink
                v-if="part.seller.__typename === $options.SellerType.SHOP"
                :href="`/seller/${part.seller.id}/${part.seller.company.id}?feedbacks=1`"
                target="_blank"
                domain="main">
                <div class="sellerInfoTable-rating area-rating">
                  <AppRating
                    :size="12"
                    :current-rating="part.seller.rating.rate"/>
                  <span
                    v-if="part.seller.rating.votes"
                    class="sellerReviews">
                    {{ part.seller.rating.votes }}
                    {{ part.seller.rating.votes | transChoose(['отзыв', 'отзыва', 'отзывов']) }}
                  </span>
                </div>
              </flink>
              <div class="sellerInfoTable-name area-name">
                <flink
                  v-if="part.seller.__typename === $options.SellerType.SHOP"
                  :href="`/seller/${part.seller.id}/${part.seller.company.id}`"
                  target="_blank"
                  @click.native="onViewShopCard(part)"
                  class="link">
                  <img
                    v-if="getShopIsConfirmed(part)"
                    svg-inline
                    src="~/assets/svg/redesign/ok-small-blue.svg">
                  <span class="sellerName __bold __hide-shadow">{{ part.seller.name }}</span>
                </flink>
                <span
                  v-else
                  class="sellerName __bold __hide-shadow">
                  <template v-if="part.seller.profile && part.seller.profile.fullname">
                    <!-- TODO: верстка для ФИО в ряд (грид не пускает) -->
                    <!-- {{ part.seller.profile.fullname.last }} -->
                    {{ part.seller.profile.fullname.first }}
                    <!-- {{ part.seller.profile.fullname.middle }} -->
                  </template>
                </span>
              </div>
              <AppWidgetChat
                v-if="part.seller.__typename === $options.SellerType.SHOP && !isSameUser(part)"
                class="area-chat"
                :id="Number(part.seller.id)"
                :button-text="`Чат`"
                :is-full="false"
                type="shop"
                @click.native="onClickChat(part)"/>
              <div
                v-if="part.seller.__typename === $options.SellerType.SHOP && part.seller.schedule"
                class="sellerInfoTable-schedule area-schedule">
                <ScheduleOpenedNow :part="getSchedule(part)"/>
              </div>
              <div class="sellerInfoTable-address area-address __medium">
                <flink
                  v-if="part.seller.__typename === $options.SellerType.SHOP"
                  :href="`/seller/${part.seller.id}/${part.seller.company.id}`"
                  target="_blank"
                  @click.native="onViewShopCard(part)"
                  class="link link-address">
                  <span class="__no-wrap">
                    {{ part.city.name }}
                    <template v-if="getAddress(part)">,</template>
                  </span>
                  <span>{{ getAddress(part) }}</span>
                </flink>
              </div>
            </div>
          </template>

          <!--цена товара-->
          <template
            :slot="`unit-${$options.headingsСontract[6].name}`"
            slot-scope="{ part }">
            <AppSellerPrice :price="round(part.cost)" />
          </template>

          <!--кнопки заказа-->
          <template
            :slot="`unit-${$options.headingsСontract[7].name}`"
            slot-scope="{ part }">
            <flink
              :href="`/do/part/${part.id}`"
              @click.native="$ym('click_ads_block')"
              target="_blank"
              class="button linkAsButton">
              Перейти к объявлению
            </flink>
            <AppSocial
              :contacts="getSellerMessengers(part)"
              @clicked="onClickedByMessengers(part)"/>
          </template>
        </AppTable>
      </div>

      <div
        v-if="tags && tags.list.length"
        class="contractParts-marks">
        <div class="boxMarks">
          <div class="boxMarks-title">
            Запчасти {{ tags.title }}
          </div>
          <ul class="boxMarks-list">
            <li
              v-for="tag in tags.list"
              :key="`mark-${tag.id}`"
              class="boxMarks-item">
              <flink
                :href="`${tag.href}#top`"
                @click.native="$ym('kz_tag_open')"
                class="link linkLight">
                {{ tag.label }}
              </flink>
            </li>
          </ul>
        </div>
      </div>
    </div>
  </AppAbstractPage>
</template>

<script>
import {
  get,
  has,
  isNil,
  isEmpty,
  find,
  pickBy,
  orderBy,
  difference,
  mapValues,
  some,
  transform,
} from 'lodash-es';
import {
  createNamespacedHelpers,
  mapState,
} from 'vuex';
import { SHOW_LOCATION_MODAL } from '~/assets/js/store/actionManager/mutation-types';

// import {
//   PartCondition as GrpcPartCondition,
// } from '~/assets/js/enums/contract-parts-grpc';


import AppAbstractPage from '~/components/redesign/layout/app-abstract-page';
import ButtonsCallHelper from '~/components/redesign/app-buttons/buttons-call-helper';
import GridHeader from '~/components/redesign/grid/grid-header';
import AppTable from '~/components/redesign/app-table/app-table';
import AppWarning from '~/components/redesign/app-warning';
import ContractFilters from '~/components/redesign/filter-groups/contract-filters';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppSellerPrice from '~/components/redesign/seller/app-seller-price';
import AppRating from '~/components/redesign/app-rating';
import AppWidgetChat from '~/components/redesign/widget/app-widget-chat';
import AppSocial from '~/components/redesign/app-social';
import SelectSorting from '~/components/redesign/app-select/select-sorting';
import ScheduleOpenedNow from '~/components/blocks/schedule-opened-now';

import { formattedCarYears, formattedPlacement } from '~/assets/js/helpers/contract-part-formatters';
import mapFilters from '~/assets/js/helpers/map-filters';
import SellerType from '~/assets/js/enums/seller-type';
import OrderDirections from '~/assets/js/enums/order-directions';
import DisplayStates from '~/assets/js/enums/do-display-states';
import ContractPart from '~/assets/js/mixins/contract-part';
import SeoMixin from '~/assets/js/mixins/seo/base';
import SeoPageMixin from '~/assets/js/mixins/seo/pages/main/do/part/index';
import { ContractParts as HeadingContract, characteristicsLabels } from '~/assets/js/mocks/table/headings';
import RouteParamsPrefixMapping from '~/assets/js/model/do/route-params-prefixes';
import InitialFiltersModel from '~/assets/js/model/do/initial-filters-model';
import CriteriaRoutingGroups from '~/assets/js/model/do/criteria-routing-groups';
import ContactTypes from '~/assets/js/enums/shop-additional-contacts';

import {
  GeoLevel,
  ContactType,
  PartCondition,
} from '~/backend/api-bundle/graphql/types';

const STORE_USER = createNamespacedHelpers('user');
const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');

export default {
  name: 'ContractParts',
  components: {
    AppSocial,
    AppWidgetChat,
    AppRating,
    AppSellerPrice,
    AppButton,
    AppWarning,
    AppAbstractPage,
    GridHeader,
    AppTable,
    ButtonsCallHelper,
    ContractFilters,
    SelectSorting,
    ScheduleOpenedNow,
  },
  mixins: [ContractPart, SeoMixin, SeoPageMixin],
  scrollToTop: false,
  watchQuery: true,
  key: to => to.fullPath,
  middleware: ['contract-parts'],
  async asyncData({
    app,
    error,
    params,
    query,
  }) {
    const limit = 20;
    const order = {
      field: 'price',
      direction: OrderDirections.ASC,
    };

    const breadcrumbs = [];
    const breadcrumbsParams = {};

    const result = {
      limit,
      order,
      emptyResult: {
        filters: false,
        city: false,
      },
      scalarFilters: [
        'condition',
        'merchantType',
        'imagesPresence',
        'priceMin',
        'priceMax',
        'text',
      ],
    };

    try {
      // парсинг query
      const apiParams = mapValues(
        {
          shop: query[CriteriaRoutingGroups.query.shop] || InitialFiltersModel.shop,
          metro: query[CriteriaRoutingGroups.query.metro] || InitialFiltersModel.metro,
          chassisList: query[CriteriaRoutingGroups.query.chassisList] || InitialFiltersModel.chassisList,
          enginesList: query[CriteriaRoutingGroups.query.enginesList] || InitialFiltersModel.enginesList,
          text: query[CriteriaRoutingGroups.query.text] || InitialFiltersModel.text,
          priceMin: query[CriteriaRoutingGroups.query.priceMin] || InitialFiltersModel.priceMin,
          priceMax: query[CriteriaRoutingGroups.query.priceMax] || InitialFiltersModel.priceMax,
          condition: Number(query[CriteriaRoutingGroups.query.condition]) || InitialFiltersModel.condition,
          merchantType: Number(query[CriteriaRoutingGroups.query.merchantType]) || InitialFiltersModel.merchantType,
          imagesPresence: query[CriteriaRoutingGroups.query.imagesPresence]
            ? Number(query[CriteriaRoutingGroups.query.imagesPresence])
            : InitialFiltersModel.imagesPresence,
          yearsList: InitialFiltersModel.yearsList,
          placementList: InitialFiltersModel.placementList,
        },
        (value, key) => {
          if (['yearsList', 'placementList'].includes(key)) {
            const queryName = CriteriaRoutingGroups.query[key];
            if (query[queryName]) {
              return Array.isArray(query[queryName]) ? query[queryName] : [query[queryName]];
            }
            return InitialFiltersModel[key];
          }
          return value;
        },
      );

      const partsType = 'Контрактные (б/у) запчасти';
      // switch (apiParams.condition) {
      //   case GrpcPartCondition.CONDITION_NEW: partsType = 'Новые запчасти'; break;
      //   case GrpcPartCondition.CONDITION_USED: partsType = 'Контрактные (б/у) запчасти'; break;
      //   default: partsType = 'Запчасти';
      // }

      // парсинг params
      let citySuffix;
      let cityValues = [];
      if (params.city) {
        const slug = params.city.replace(RouteParamsPrefixMapping.city, '');
        ({ data: cityValues } = await app.$axios.$get('/_main/geo/get', {
          params: { slugs: [slug] },
        }));
        const value = cityValues[0];
        apiParams.city = value ? value.id : null;
        citySuffix = value ? `в ${value.prepositionalName}` : 'во всех городах';
        breadcrumbsParams.city = params.city;
        breadcrumbs.push({
          name: `${partsType} ${citySuffix}`,
          url: app.router.resolve({ name: 'do-part', params: breadcrumbsParams }).href,
        });
      } else {
        error({ statusCode: 404 });
        return {};
      }

      let carManufacturerValues = [];
      if (params.carManufacturer) {
        ({ data: carManufacturerValues } = await app.$axios.$get('/_main/contractParts/getCarManufacturers', {
          params: { hasHidden: 'true' },
        }));
        const slug = params.carManufacturer.replace(RouteParamsPrefixMapping.carManufacturer, '');
        const value = find(carManufacturerValues, { slug });
        if (!value || !value.id) {
          error({ statusCode: 404 });
          return {};
        }
        apiParams.carManufacturer = value.id;
        breadcrumbsParams.carManufacturer = params.carManufacturer;
        breadcrumbs.push({
          name: value.name,
          url: app.router.resolve({ name: 'do-part', params: breadcrumbsParams }).href,
        });
      }

      let carModelValues = [];
      if (params.carModel) {
        ({ data: carModelValues } = await app.$axios.$get('/_main/contractParts/getCarModels', {
          params: { carManufacturer: apiParams.carManufacturer, hasHidden: 'true' },
        }));
        const slug = params.carModel.replace(RouteParamsPrefixMapping.carModel, '');
        const value = find(carModelValues, { slug });
        if (!value || !value.id) {
          error({ statusCode: 404 });
          return {};
        }
        apiParams.carModel = value.id;
        breadcrumbsParams.carModel = params.carModel;
        breadcrumbs.push({
          name: value.name,
          url: app.router.resolve({ name: 'do-part', params: breadcrumbsParams }).href,
        });
      }

      // запрос данных
      const apiResult = await Promise.all([
        app.$axios.$get('/_main/contractParts/list', {
          params: { order, limit, criteria: apiParams },
        }),
        app.$axios.$get('/_main/contractParts/filters', {
          params: apiParams,
        }),
      ]);
      let [{ data: { data, count } }] = apiResult;
      const [, { data: { total: countFilters, ...filtersValues } }] = apiResult;

      // fallback для пустого результата
      if (!count) {
        let criteria = {};
        const nonCityCriteria = pickBy(apiParams, (value, key) => key !== 'city' && value !== InitialFiltersModel[key]);
        const onlyCitySelected = isEmpty(nonCityCriteria);
        if (!onlyCitySelected) {
          criteria = {
            city: apiParams.city,
            carManufacturer: apiParams.carManufacturer,
            carModel: apiParams.carModel,
          };
        }
        ({ data: { data, count } } = await app.$axios.$get('/_main/contractParts/list', {
          params: {
            order,
            limit,
            criteria,
          },
        }));
        result.emptyResult.city = onlyCitySelected;
        result.emptyResult.filters = !onlyCitySelected;
      }

      // установка значений из урла в фильтры
      const filtersModel = {
        ...pickBy(apiParams, (value, key) => result.scalarFilters.includes(key)),
        ...mapValues(
          pickBy(apiParams, (value, key) => Boolean(value)
            && !result.scalarFilters.includes(key)
            && !['yearsList', 'placementList'].includes(key)),
          (value, key) => {
            let searchValues;
            switch (key) {
              case 'city':
                searchValues = cityValues;
                break;
              case 'carManufacturer':
                searchValues = carManufacturerValues;
                break;
              case 'carModel':
                searchValues = carModelValues;
                break;
              default:
                searchValues = filtersValues[key];
            }
            let filterModel;
            switch (key) {
              case 'chassisList':
              case 'enginesList':
                filterModel = find(searchValues, svalue => String(svalue.slug) === String(value));
                break;
              default:
                filterModel = find(searchValues, svalue => Number(svalue.id) === Number(value));
            }
            if (!filterModel) {
              return InitialFiltersModel[key];
            }
            if (!filtersValues[key].length) {
              filtersValues[key].push(filterModel);
            }
            return filterModel;
          }
        ),
        yearsList: apiParams.yearsList
          .filter(year => some(filtersValues.yearsList, value => Number(value.id) === Number(year)))
          .map((year) => {
            const model = find(filtersValues.yearsList, value => Number(value.id) === Number(year));
            return model;
          }),
        placementList: apiParams.placementList.map(placement => Number(placement)),
      };

      breadcrumbs[breadcrumbs.length - 1].url = '';

      return {
        ...result,
        data,
        count,
        filtersValues,
        filtersModel,
        breadcrumbs,
        partsType,
      };
    } catch (e) {
      console.error(e);
      error({ statusCode: 500 });
    }

    return {};
  },
  data() {
    let display = this.$cookies.get('doDisplay');
    const filtersMobileScrollable = display === DisplayStates.FILTERS;
    if (!display || !Object.values(DisplayStates).includes(display)) {
      display = DisplayStates.LIST;
    }
    return {
      display,
      offset: 0,
      loading: false,
      filtersMobileScrollable,
      primaryFilters: [
        'city',
        'carManufacturer',
        'carModel',
      ],
      selectedSorting: null,
    };
  },
  computed: {
    ...mapState(['location']),
    ...STORE_USER.mapState(['auth']),
    grid() {
      return {
        data: this.data,
        name: (() => {
          switch (true) {
            case this.emptyResult.city: return `Объявление в других городах: ${this.spacifyNumber(this.count)}`;
            case this.emptyResult.filters: return `Другие объявления ${this.requestExplain}:
              ${this.spacifyNumber(this.count)}`;
            default: return '';
          }
        })(),
        count: this.count,
        order: this.order,
        offset: this.offset,
        countShown: this.lazyLoadEnabled ? this.limit + this.offset : this.count,
      };
    },
    routingParams() {
      const routingParams = mapValues(
        pickBy(
          this.getApiCriteriaList(),
          (item, key) => item
            && this.filtersModel[key]
            && CriteriaRoutingGroups.params.includes(key),
        ),
        (item, key) => `${RouteParamsPrefixMapping[key]}${this.filtersModel[key].slug}`,
      );
      if (!has(routingParams, 'city')) {
        routingParams.city = `${RouteParamsPrefixMapping.city}all_city`;
      }
      return routingParams;
    },
    routingQuery() {
      return transform(
        pickBy(
          this.getApiCriteriaList(),
          (item, key) => item
            && (!Array.isArray(item) || item.length)
            && has(CriteriaRoutingGroups.query, key),
        ),
        (result, param, key) => {
          let value = param;
          if (key === 'yearsList') {
            const diffIds = difference(
              this.filtersModel.yearsList.map(item => item.id),
              this.filtersValues.yearsList.map(item => item.id),
            );
            if (diffIds.length) {
              value = value.filter(item => !diffIds.includes(item));
            }
          }
          const queryKey = CriteriaRoutingGroups.query[key];
          result[queryKey] = value;
        },
        {},
      );
    },
    lazyLoadEnabled() {
      return this.count > this.limit && (this.limit + this.offset) < this.count;
    },
    loadEnabled() {
      const targetHref = this.$router.resolve({
        name: 'do-part',
        params: this.routingParams,
        query: this.routingQuery,
      }).href;
      return targetHref !== this.$route.fullPath;
    },
    unboundFiltersModel() {
      return { ...this.filtersModel };
    },
    requestExplain() {
      const requestExplain = [];

      const carManufacturer = this.getRouteParamValue('carManufacturer');
      carManufacturer && requestExplain.push(`для ${carManufacturer.name}`);

      const carModel = this.getRouteParamValue('carModel');
      carModel && requestExplain.push(`${carModel.name}`);

      const city = this.getRouteParamValue('city');
      requestExplain.push(city ? `в ${city.prepositionalName}` : 'во всех городах');

      return requestExplain.join(' ');
    },
    title() {
      return [
        this.partsType,
        this.requestExplain,
      ].join(' ');
    },
    tags() {
      let title = '';
      let field = null;
      let list = [];

      if (!this.$route.params.carManufacturer && !this.$route.params.carModel) {
        if (this.$route.params.city === `${RouteParamsPrefixMapping.city}all_city`) {
          title = 'по городу';
          field = 'city';
          list = this.filtersValues.city.map(item => ({
            ...item,
            href: this.$router.resolve({
              name: 'do-part',
              params: { city: `${RouteParamsPrefixMapping.city}${item.slug}` },
            }).href,
          }));
        } else {
          title = 'по маркам авто';
          field = 'carManufacturer';
          list = this.filtersValues.carManufacturer.map(item => ({
            ...item,
            href: this.$router.resolve({
              name: 'do-part',
              params: {
                city: this.$route.params.city,
                carManufacturer: `${RouteParamsPrefixMapping.carManufacturer}${item.slug}`,
              },
            }).href,
          }));
        }
      } else if (!this.$route.params.carModel) {
        title = 'по моделям авто';
        field = 'carModel';
        list = this.filtersValues.carModel.map(item => ({
          ...item,
          href: this.$router.resolve({
            name: 'do-part',
            params: {
              city: this.$route.params.city,
              carManufacturer: this.$route.params.carManufacturer,
              carModel: `${RouteParamsPrefixMapping.carModel}${item.slug}`,
            },
          }).href,
        }));
      } else {
        return {
          title,
          field,
          list,
        };
      }

      return {
        title,
        field,
        list: orderBy(list, ['total'], ['desc'])
          .slice(0, 20)
          .map(item => ({
            id: item.id,
            label: item.name,
            value: { ...item },
            href: item.href,
          })),
      };
    },
    sorting() {
      return this.$options.headingsСontract
        .filter(entry => entry.sorting.has)
        .reduce((acc, entry) => acc.concat(
          {
            id: `${OrderDirections.ASC}${entry.sorting.criteria}`,
            criteria: entry.sorting.criteria,
            titleMobile: entry.titleMobile,
            direction: OrderDirections.ASC,
          },
          {
            id: `${OrderDirections.DESC}${entry.sorting.criteria}`,
            criteria: entry.sorting.criteria,
            titleMobile: entry.titleMobile,
            direction: OrderDirections.DESC,
          }
        ), []);
    },
    isCurrentLocationCity() {
      return this.location.id && this.location.level === GeoLevel.City;
    },
  },
  watch: {
    async order() {
      if (this.loading) {
        return false;
      }
      this.offset = 0;
      const { data, count } = { ...await this.fetchNewDataPart() };
      this.data = data;
      this.count = count;
      return true;
    },
    unboundFiltersModel: {
      async handler() {
        await this.loadNewData();
      },
      deep: true,
    },
    'location.id'() {
      this.filtersModel = {
        ...InitialFiltersModel,
        city: this.location,
      };
    },
  },
  created() {
    this.$options.headingsСontract = HeadingContract;
    this.$options.displayStates = DisplayStates;
    this.$options.SellerType = SellerType;
    this.$options.charсLabels = characteristicsLabels;
  },
  mounted() {
    this.$nextTick(() => {
      if (this.$route.hash) {
        window.location.hash = this.$route.hash;
      }
    });
    this.selectedSorting = this.sorting[2];
  },
  methods: {
    ...mapFilters(['spacifyNumber', 'round', 'transChoose']),
    ...STORE_ACTION_MANAGER.mapMutations({
      showLocationModal: SHOW_LOCATION_MODAL,
    }),
    getApiCriteriaList(forPager = false) {
      if (forPager && this.emptyResult.city) {
        return {};
      }

      return mapValues(
        pickBy(
          this.filtersModel,
          (value, param) => !isNil(value)
            && (
              !forPager
              || !this.emptyResult.filters
              || this.primaryFilters.includes(param)
            ),
        ),
        (value, key) => {
          switch (true) {
            case (this.scalarFilters.includes(key)):
            case (key === 'placementList'):
              return value;
            case (key === 'yearsList'):
              return value.map(year => Number(year.id));
            case (key === 'enginesList'):
            case (key === 'chassisList'):
              return value.slug;
            default:
              return Number(value.id);
          }
        },
      );
    },
    async fetchNewDataPart() {
      if (this.loading) {
        return false;
      }
      try {
        this.loading = true;
        const { data: { data, count } } = await this.$axios.$get('/_main/contractParts/list', {
          params: {
            criteria: this.getApiCriteriaList(true),
            limit: this.limit,
            offset: this.offset,
            order: this.order,
          },
        });
        return { data, count };
      } catch (e) {
        console.error(e);
        this.$error({ statusCode: 500 });
      } finally {
        this.loading = false;
      }
      return {};
    },
    async showMore() {
      if (!this.lazyLoadEnabled) {
        return false;
      }
      this.offset += this.limit;
      const { data } = { ...await this.fetchNewDataPart() };
      this.data = this.data.concat(data);
      return true;
    },
    loadNewData() {
      if (!this.loadEnabled) {
        return false;
      }
      this.loading = true;
      this.$router.push({
        name: 'do-part',
        params: this.routingParams,
        query: this.routingQuery,
      });
      return true;
    },
    resetFilters() {
      if (this.loading) {
        return false;
      }

      const route = {
        name: 'do-part',
        params: { city: `${RouteParamsPrefixMapping.city}all_city` },
      };
      const targetHref = this.$router.resolve(route).href;

      if (this.$route.fullPath === targetHref) {
        this.filtersModel = { ...InitialFiltersModel };
        return true;
      }

      this.loading = true;
      this.$router.push(route);
      return true;
    },
    changeDisplay(target) {
      if (!Object.values(DisplayStates).includes(target)) {
        return false;
      }
      this.display = target;
      this.filtersMobileScrollable = target === DisplayStates.FILTERS;
      this.$cookies.set('doDisplay', target, {
        domain: `.${this.$config.domains.base}`,
        path: '/',
        maxAge: 60 * 60 * 24 * 365 * 10,
      });
      return true;
    },
    getRouteParamValue(paramName) {
      if (!this.$route.params[paramName]) {
        return false;
      }
      const slug = this.$route.params[paramName].replace(RouteParamsPrefixMapping[paramName], '');
      return find(this.filtersValues[paramName], { slug });
    },
    onOrderChange(payload) {
      if (!payload.id) {
        const option = this.$options.headingsСontract.find(item => item.sorting.criteria === payload.field);
        this.selectedSorting = option;
      } else {
        this.selectedSorting = payload;
      }

      this.order = {
        field: payload.criteria,
        direction: payload.direction,
      };
    },
    onClickChat(part) {
      if (!part.statisticsData) {
        return;
      }
      this.$statDo('click-chat', part.statisticsData);
    },
    onViewShopCard(part) {
      if (!part.statisticsData) {
        return;
      }
      this.$statDo('view-shop-card', part.statisticsData);
    },
    onClickedByMessengers(part) {
      if (!part.statisticsData) {
        return;
      }
      this.$statDo('view-messenger', part.statisticsData);
    },
    isSameUser(part) {
      if (
        !this.auth
        || !this.auth.isOrganization
        || part.seller.__typename !== SellerType.SHOP
      ) {
        return false;
      }
      return this.auth.organization
        && this.auth.organization.legals
        && this.auth.organization.legals.some(
          legal => legal.shops.some(shop => Number(shop.id) === Number(part.seller.id))
        );
    },
    getCondition(part) {
      return part.partCondition === PartCondition.Used ? 'Б/у' : 'Новая';
    },
    getAddress(part) {
      if (part.seller.__typename !== SellerType.SHOP) {
        return null;
      }

      if (part.seller.isNetshop) {
        return 'интернет магазин';
      }

      return [
        get(part, 'seller.address.street', null),
        get(part, 'seller.address.building', null),
        get(part, 'seller.address.office', null) && `офис ${part.seller.address.office}`,
      ].filter(Boolean).join(', ');
    },
    getShopIsConfirmed(part) {
      return part.seller.__typename === SellerType.SHOP && (
        get(part.seller, 'websites', []).some(item => item.isConfirmed)
        || get(part.seller, 'emails', []).some(item => item.isConfirmed)
        || get(part.seller, 'phones', []).some(item => item.isConfirmed)
        || get(part.seller, 'messengers', []).some(item => item.isConfirmed)
        || get(part.seller, 'address.isConfirmed', false)
        || get(part.seller, 'schedule.isConfirmed', false)
      );
    },
    getSellerMessengers(part) {
      if (!part.seller.messengers || !part.seller.messengers.length) {
        return [];
      }
      return part.seller.messengers.map(messenger => ({
        type_id: (() => {
          switch (messenger.kind) {
            case ContactType.Skype: return ContactTypes.SKYPE;
            case ContactType.Icq: return ContactTypes.ICQ;
            case ContactType.Telegram: return ContactTypes.TELEGRAM;
            case ContactType.Whatsapp: return ContactTypes.WHATSAPP;
            case ContactType.Viber: return ContactTypes.VIBER;
            default: return null;
          }
        })(),
        value: messenger.value,
      }));
    },
    getSchedule(part) {
      const schedule = get(part, 'seller.schedule.legacy') || [];
      [
        'current_date_time_with_tz',
        'opening_date_time',
        'close_date_time',
        'dinner_begin_date_time',
        'dinner_end_date_time',
      ].forEach((key) => {
        if (!schedule[key]) {
          return;
        }
        schedule[key]
          .replace('T', ' ')
          .replace('Z', '')
          .replace(/[+-]{1}[0-9]{2}:[0-9]{2}/, '');
      });
      return schedule;
    },
    getCharacteristics(part) {
      return [
        {
          name: this.$options.charсLabels.carManufacturer,
          value: part.car.manufacturer.name,
        },
        {
          name: this.$options.charсLabels.carModel,
          value: part.car.name,
        },
        {
          name: this.$options.charсLabels.carChassis,
          value: Array.isArray(part.carChassis) && part.carChassis.length
            ? part.carChassis.join(', ')
            : '',
        },
        {
          name: this.$options.charсLabels.carEngine,
          value: Array.isArray(part.carEngines) && part.carEngines.length
            ? part.carEngines.join(', ')
            : '',
        },
        {
          name: this.$options.charсLabels.carYears,
          value: part.carYears ? formattedCarYears(part.carYears) : '',
        },
        {
          name: this.$options.charсLabels.color,
          value: part.color ? part.color : '',
        },
        {
          name: this.$options.charсLabels.partManufacturer,
          value: part.part && part.part.manufacturer ? part.part.manufacturer.name : '',
        },
        {
          name: this.$options.charсLabels.vendorCode,
          value: part.part ? part.part.vendorCode : '',
        },
        {
          name: this.$options.charсLabels.placement,
          value: Array.isArray(part.partPlacement) && part.partPlacement.length
            ? formattedPlacement(part.partPlacement)
            : '',
        },
      ].filter(item => item.value);
    },
  },
};

</script>

<style lang="postcss">
  /* Стили для блоков с инфой о продавце */
  @import '~/assets/css/components/seller-info.css';
  /* autoprefixer: off */
  .pageHeading {
    display: flex;
    justify-content: space-between;

    &-basic {
      display: block;
    }

    &-additional {
      display: inline-flex;
      align-items: flex-end;
      margin-top: -1rem;
    }

    @media screen and (max-width: 980px) {
      flex-direction: column;

      &-additional {
        margin: 0 auto;
        width: 100%;
      }

      .buttonsCallHelper {
        margin-top: 1rem;
      }
    }
  }


  /* Стили для блоков с инфой, когда что-то не найдено */
  .searchAdditional {
    display: block;
    width: 100%;

    &-form {
      display: flex;
      padding: 1.5rem;
      border-radius: 0;

      .form {
        display: flex;
        justify-content: center;
        align-items: center;
        width: 100%;

        &-item {
          display: flex;
          flex-direction: column;
          margin-right: 1.25rem;
        }
      }

      &._align-center {
        justify-content: center;
      }
    }

    @media screen and (min-width: 981px) {
      position: relative;
      margin-bottom: -0.125rem;

      .input {
        width: 26rem;
      }

      .multiselect {
        width: 14.5rem;
      }
    }

    @media screen and (max-width: 980px) {
      &-form {
        padding-left: 1.25rem;
        padding-right: 1.25rem;

        .form {
          flex-direction: column;
          width: 100%;

          &-item {
            margin: 0;
            width: 100%;
          }

          .form-item + .form-item {
            margin-top: 0.75rem;
          }

          .input {
            width: 100%;
            height: var(--btn-mobile-min-height);
          }

          .multiselect {
            width: 100%;
          }
        }
      }
    }
  }

  .contractParts {
    display: block;
    padding-bottom: 4rem;

    .appWarning {
      margin-top: 1rem;
      margin-bottom: 0;
    }

    @media screen and (max-width: 980px) {
      position: relative;

      .appWarning {
        margin-bottom: 1rem;
      }
    }

    &-warning {
      padding: 1.5rem 0 0 0;

      @media screen and (max-width: 980px) {
        padding-top: 0;
        padding-bottom: 0;
        > .row {
          flex-direction: column;
          align-items: flex-start;
          padding: 0 1.25rem;
        }
        .buttonsCallHelper {
          margin-top: 1rem;
        }
      }
    }

    &-table {
      @media screen and (min-width: 981px) {
        .grid-header {
          padding: 0 0 0.65rem 0;
        }
      }

      @media screen and (max-width: 980px) {
        .grid-header {
          .button.buttonFilters {
            margin: 0;
          }
        }
      }
    }

    &-filters {
      margin-bottom: 1rem;

      @media screen and (min-width: 981px) {
        z-index: 11;
        position: relative;
      }

      .boxFilters {
        display: block;

        @media screen and (max-width: 980px) {
          display: none;
          z-index: 1000;
          &.-open-in-mobile {
            display: block;
          }
          .filterGroup {
            background-color: var(--bg-lightest);
          }
        }
      }
    }

    .boxPopular {
      display: block;
      padding: 1.5rem 0 0;
      font-size: 0.75rem;

      &-title {
        display: block;
        padding-bottom: 0.75rem;
        font-weight: var(--font-weight-medium);
      }

      &-list {
        display: block;
        column-gap: 4%;
        column-count: 7;
        column-fill: balance;
      }

      &-item {
        padding-bottom: 0.75rem;
        cursor: pointer;
      }

      &-button {
        display: flex;
        justify-content: flex-start;
        margin-left: auto;
        width: calc((100% - 24%) / 7);
      }

      .linkDark {
        cursor: pointer;
      }

      @media (min-width: 981px) and (max-width: 1200px) {
        font-size: 0.875rem;

        &-list {
          column-count: 5;
          max-height: 6rem;
          overflow: hidden;
        }

        &-button {
          width: calc((100% - 16%) / 5);
        }
      }

      @media screen and (max-width: 981px) {
        display: none;
      }
    }

    .boxMarks {
      display: block;
      padding: 2.5rem 0 0;
      font-size: 0.75rem;

      &-title {
        display: block;
        padding-bottom: 0.75rem;
        font-weight: var(--font-weight-medium);
      }

      &-list {
        display: block;
      }

      &-item {
        display: inline-block;
        padding-right: 1rem;
        padding-bottom: 0.75rem;
      }

      @media (min-width: 981px) and (max-width: 1200px) {
        padding-top: 2rem;
        font-size: 0.875rem;
      }

      @media screen and (max-width: 980px) {
        display: none;
      }
    }

    .buttonPopular {
      display: flex;
      align-items: center;
      margin: 0 -1.25rem 1rem;
      padding: 1.5rem 1.25rem;
      width: calc(100% + 2.5rem);
      font-size: 1.125rem;
      line-height: 1;
      font-weight: var(--font-weight-medium);
      background: none;
      border-top: 1px solid var(--border-color-light);
      border-bottom: 1px solid var(--border-color-light);
      border-right: none;
      border-left: none;
      outline: none;

      .svg {
        margin-left: auto;
        width: 0.375rem;
        height: auto;
      }

      @media screen  and (min-width: 981px) {
        display: none;
      }
    }

    /* Стили для таблицы популярных запросов */

    .tableContracts {
      .tr.-outdated {
        background-color: var(--bg-lightest);
        .__hide-shadow:after {
          background-image: linear-gradient(270deg,var(--bg-dark) .5rem, var(--bg-transparent));
        }
      }

      .th, .td {
        &._createdAd {
          grid-area: createdAd;
        }

        &._sellerBasic {
          grid-area: sellerBasic;

          .seller-grid {
            display: grid;
            grid-template-columns: 1fr 3.875rem;
            grid-template-rows: auto auto auto 1fr;
            grid-template-areas: "name chat" "address chat" "social social";
            height: 100%;

            .area-rating {
              grid-area: rating;
              padding-bottom: 0.75rem;
            }

            .area-name {
              grid-area: name;
            }

            .area-chat {
              grid-area: chat;
              margin-left: 1.5rem;
            }

            .area-address {
              grid-area: address;
              overflow: hidden;

              .link-address {
                display: block;
              }
            }

            .area-scl {
              grid-area: social;
            }
          }
        }

        &._delivery {
          grid-area: delivery;

          .in-stock-badge {
            padding: 0.225rem 0.5rem;
            background-color: var(--online-color);
            border-radius: 0.25rem;
            text-align: center;
            color: #fff;
          }

          .quantity {
            margin-top: 0.25rem;
            padding-left: 0.5rem;
          }
        }

        &._condition {
          grid-area: condition;
        }

        &._partName {
          grid-area: partName;

          .characteristics-list {
            margin-top: 0.25rem;
            width: 100%;
            @media screen and (min-width: 981px) {
              max-width: 8.5rem;
            }

            &-item {
              white-space: nowrap;
            }
          }
        }

        &._img {
          grid-area: img;

          .sellerPrivate {
            display: none;
          }

          .picture {
            > .svg {
              width: 3.5rem;
              height: auto;
              fill: var(--fill-light);
            }

            @media screen and (min-width: 981px) {
              padding-top: 100%;

              > img {
                left: 0;
                top: 0;
                transform: none;
              }
            }
          }
        }

        &._price {
          grid-area: price;
          align-items: flex-end;
        }

        &._buttonsOrder {
          grid-area: buttonsOrder;

          .sclContacts {
            margin: 1rem 0 0 auto;
          }

          .value {
            display: block;
            margin: 0 auto;
            font-size: 0.875rem;
          }
        }
      }

      @media screen and (min-width: 981px) {
        .tr {
          grid-template-columns: 6.5rem 1fr 5rem 6rem 7.5rem 1.5fr 1fr 15rem;
          grid-template-areas: "img partName condition createdAd delivery sellerBasic price buttonsOrder";
          transition: margin 0.2s var(--transition-easeOutQuad),
          padding 0.2s var(--transition-easeOutQuad),
          box-shadow 0.3s var(--transition-easeOutQuad);
        }

        .tbody {
          background-color: var(--bg-main);
          .tr {
            &:hover {
              position: relative;
              z-index: 1;
              margin: 0 -0.375rem 0 -0.375rem;
              padding: 0 0.375rem;
              border-color: transparent;
              background-color: var(--bg-main);
              box-shadow: 0 0 0 1px var(--border-color-light), 0 2px 5px rgba(0, 0, 0, 0.11);
            }

            .td {
              border-top-color: transparent;
            }
          }
        }

        .td {
          display: flex;
          flex-direction: column;
          justify-content: flex-start;

          &._img {
            padding: 1rem 0 0;
            border-right: 1px solid var(--border-color-main);
          }

          &._partName {
            align-items: flex-start;

            .buttonIsMobile {
              display: none;
            }

            .sellerPrivate {
              margin-bottom: 0.375rem;
            }

            .sellerConditionPart {
              padding-top: 0.375rem;
              font-weight: var(--font-weight-bold);
            }
          }

          &._sellerBasic {
            .sellerBasic {
              padding: 1rem;
              background-color: var(--bg-dark);

              .__hide-shadow:after {
                background-image: linear-gradient(270deg, var(--bg-dark) .5rem, var(--bg-transparent));
              }
            }

            .sellerContacts {
              margin: 0.375rem auto 0 0;

              .sclContacts {
                justify-content: flex-start;
                margin-left: 0;
              }
            }
          }

          &._price {
            align-items: flex-end;
          }

          .value {
            padding-bottom: 0.375rem;
          }

          .valueIsMobile {
            display: none;
          }
        }

        .buttonOrder {
          width: 100%;
        }

        .buttonFilters {
          display: none;
        }
      }

      @media (min-width: 981px) and (max-width: 1200px) {
        .thead .tr {
          grid-template-areas: "partName condition createdAd sellerBasic price";
          .th._buttonsOrder {
            display: none;
          }
          .th._delivery {
            display: none;
          }
        }
        .tr {
          /* grid-template-columns: minmax(12.75rem, 17rem) minmax(6rem, 6.5rem)
          minmax(7.5rem, 11.25rem) minmax(16.25rem, 30rem) 12rem; */
          grid-template-columns: 2fr 1fr 1fr 2fr 12rem;
          grid-template-areas:
            "img condition createdAd sellerBasic price"
            "img condition createdAd sellerBasic buttonsOrder"
            "delivery delivery createdAd sellerBasic buttonsOrder"
            "partName partName partName sellerBasic buttonsOrder";
        }

        .th {
          align-items: center;
          justify-content: center;
          text-align: center;

          ._img {
            display: none;
          }
        }

        .td {
          justify-content: flex-start;

          &._img {
            align-items: flex-start;
            padding: 1rem 1rem 0 1rem;
            border-right: none;

            .sellerPrivate {
              display: block;
              margin-bottom: 0.375rem;
            }

            .picture {
              width: 6.25rem;
            }
          }

          &._partName {
            align-items: flex-start;
            padding: 0.625rem 1rem 1rem 1rem;
            border-top: none;

            .sellerPrivate {
              display: none;
            }

            .sellerConditionPart {
              padding-top: 0.375rem;
              font-weight: var(--font-weight-bold);
            }
          }

          &._delivery {
            display: flex;
            flex-direction: row;
            padding-left: 1rem;

            .value {
              margin-left: 0.5rem;

              &.__bold {
                font-weight: var(--font-weight-medium);
              }
            }

            .valueIsMobile {
              display: block;
            }
          }

          &._sellerBasic {
            .seller-grid {
              grid-template-columns: 1fr 4rem;
            }

            .sellerBasic-address {
              .__no-wrap {
                white-space: normal;
              }

              .__hide-shadow:after {
                content: none;
              }
            }

            .sellerContacts {
              .sclContacts-item {
                margin-left: 0.4375rem;
              }
            }
          }

          &._price {
            padding-right: 1rem;
          }

          &._buttonsOrder {
            padding-right: 1rem;
            border-top: none;
          }
        }
      }

      @media screen and (max-width: 980px) {
        .tr {
          position: relative;
          grid-template-columns: 6.625rem 1fr 6.625rem;
          grid-template-areas:
            "createdAd condition condition"
            "partName partName img"
            "delivery delivery delivery"
            "price price price"
            "sellerBasic sellerBasic sellerBasic"
            "buttonsOrder buttonsOrder buttonsOrder";

          &.-outdated {
            grid-template-areas:
              "createdAd createdAd createdAd"
              "condition condition condition"
              "partName partName img"
              "delivery delivery delivery"
              "price price price"
              "sellerBasic sellerBasic sellerBasic"
              "buttonsOrder buttonsOrder buttonsOrder";
          }

          .td._createdAd {
            padding-bottom: 0.625rem;

            .td-updated,
            .td-requests {
              display: inline-block;
              padding-right: 0.75rem;
              padding-bottom: 0.125rem;
              font-size: 0.875rem;
              white-space: nowrap;
            }
          }

          .td._condition,
          .td._delivery {
            display: flex;
            justify-content: flex-end;
            padding-bottom: 0.625rem;

            .value {
              margin-left: 0.5rem;

              &.__bold {
                font-weight: var(--font-weight-medium);
              }
            }
          }

          .td._delivery {
            justify-content: flex-start;
          }

          .td._sellerBasic {
            position: relative;
            z-index: 3;

            .sellerInfoTable {
              grid-template-rows: auto 1fr auto auto;
              margin-bottom: 1rem;
            }
            .seller-grid {
              grid-template-columns: 1fr 5.25rem;
              grid-template-areas: "name chat" "address chat";

              .sellerBasic-item.area-name {
                max-width: 100%;
                overflow: hidden;
              }

              .sellerBasic-item.area-rating {
                padding-bottom: 0.375rem;
              }
            }

            .sellerContacts {
              display: none;
            }
          }

          .td._partName {
            padding-bottom: 0.625rem;
            font-size: 1rem;

            .buttonIsMobile {
              position: absolute;
              z-index: 2;
              top: 0;
              left: 0;
              display: block;
              width: 100%;
              height: 100%;
              opacity: 0;
            }

            .sellerPrivate {
              display: inline-block;
              margin-bottom: 0.625rem;
            }

            .link {
              display: block;
            }

            .sellerConditionPart {
              padding: 0.625rem 0;
              font-size: 0.875rem;
              font-weight: var(--font-weight-medium);
            }
          }

          .td._img {
            padding-left: 1rem;

            .picture {

              > .svg {
                width: 2.5rem;
              }
            }
          }

          .td._buttonsOrder {
            position: relative;
            z-index: 3;
            .value {
              font-size: 1rem;
              font-weight: var(--font-weight-medium);
            }
            .linkAsButton {
              width: 100%;
              font-size: 1rem;
            }
          }
        }

      }
    }
  }
</style>
